/***************************************************************************
 *   Copyright (C) 2007 by Bartosz Hoffmann  				             *
 *   monocrystal@o2.pl   										     *
 *                                                                        						     *
 ***************************************************************************/
#include "kpoldekwindow.h"

KpoldekWindow::KpoldekWindow(QWidget *parent)
     : QMainWindow(parent)
{
	Installed = new QTreeWidgetItem();
	notInstalled = new QTreeWidgetItem();

	about = new AboutDialog();
	setupUi(this);
	
	
	setupInterface();
	setPoldekSignals();
	menuSetup();
	buttonActions();

	setDisabled ( true );
	poldek.InstalledList();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::showAllDesc( QListWidgetItem *  item ) {
	//Tekst formatowany HTML --- proste znaczniki :-) w obu funkcjach ponizej 
	pkgDescription->setText("<h1>"   + poldek.getAllValue(item->text() , "File:" ) + "</h1><hr>" );
	pkgDescription->append(	"<table><tr><td><i><b>Description:</b></i></td><td>" + poldek.getAllValue(item->text() , QString("Description:") ) + "</td></tr></table>");
		for ( QStringList::Iterator iter= poldek.header.begin() ; iter != poldek.header.end()-1 ; ++iter )
		{
			pkgDescription->append (	"<table><tr><td><i><b>" + *iter +  "</b></i></td><td>" + poldek.getAllValue(item->text() , *iter ) + "</td></tr></table>");
		}
	pkgDescription->moveCursor ( QTextCursor::Start );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::showInstaledDesc( QListWidgetItem *  item ) {
	pkgDescription->setHtml( "<h1>"   + poldek.getInstalledValue(item->text() , "File:" ) + "</h1><hr>");
	pkgDescription->append(	"<table><tr><td><i><b>Description:</b></i></td><td>" + poldek.getInstalledValue(item->text() , QString("Description:") ) + "</td></tr></table>");
		for ( QStringList::Iterator iter= poldek.header.begin() ; iter != poldek.header.end()-1 ; ++iter )
		{
			pkgDescription->append (	"<table><tr><td><i><b>" + *iter +  "</b></i></td><td>" + poldek.getInstalledValue(item->text() , *iter ) + "</td></tr></table>");
		}
	pkgDescription->append ( "");
	pkgDescription->moveCursor ( QTextCursor::Start );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::showInstaledList(QTreeWidgetItem * item , int column )
{
	QStringList InstalledKeys = poldek.getInstalledKeys();
	listPkg->clear();
	
	QString Groups;
	QTreeWidgetItem *tmp_item = item;
		while ( !Groups.contains ("/Root"))
		{
			Groups.prepend ( "/" +tmp_item->text (column) );
			tmp_item = tmp_item->parent ();
		}
	Groups.remove ( "/Root/");
	
	for ( QStringList::Iterator it = InstalledKeys.begin() ; it  != InstalledKeys.end(); ++it )
	{
		if ( poldek.getInstalledValue( *it , "Group:" ).contains( Groups ) )
		{
			if ( !UninstallList.contains(*it) ){
			QListWidgetItem *item = new QListWidgetItem ( QIcon(":/package.png") ,*it );
			item->setToolTip ( poldek.getInstalledValue( *it , "Summary:" )  + "\nFile:"
							+poldek.getInstalledValue( *it , "File:" ) );
			listPkg->addItem(item);
			}
		}
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::showAllList(QTreeWidgetItem * item , int column )
{
	QStringList AllKeys = poldek.getAllKeys();
	QStringList InstalledKeys = poldek.getInstalledKeys();
	
	listPkg_2->clear();

	QString Groups;
	QTreeWidgetItem *tmp_item = item;
		while ( !Groups.contains ("/Root"))
		{
			Groups.prepend ( "/" +tmp_item->text (column) );
			tmp_item = tmp_item->parent ();
		}
	Groups.remove ( "/Root/");
	
	for ( QStringList::Iterator it = AllKeys.begin() ; it  != AllKeys.end(); ++it )
	{
		if ( poldek.getAllValue( *it , "Group:" ).contains(item->text(column)) )
		{
			if ( !installList.contains(*it) && !InstalledKeys.contains(*it) )
			{
			QListWidgetItem *item = new QListWidgetItem ( QIcon(":/package.png") ,*it );
			item->setToolTip ( poldek.getAllValue( *it , "Summary:" )  + "\nFile:"
							+poldek.getAllValue( *it , "File:" ) );
			listPkg_2->addItem(item);
			}
		}
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::showAllGroups () {
	QStringList tmp = poldek.getAllKeys();
	QStringList Groups;
	for ( QStringList::Iterator it = tmp.begin() ; it  != tmp.end(); ++it )
	{
		if (!Groups.contains("#" + poldek.getAllValue( *it , "Group:" )))
		{
			Groups << "#" + poldek.getAllValue( *it , "Group:" );
		}
	}
	Groups.sort();
	Groups << "#END";
	notInstalled->addChildren ( makeTree (  Groups ) ) ;
	tree_2->addTopLevelItem(notInstalled);
	setDisabled ( false );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::showInstalledGroups() {
	QStringList InstalledKeys = poldek.getInstalledKeys();
	QStringList Groups;
	for ( QStringList::Iterator it = InstalledKeys.begin() ; it  != InstalledKeys.end(); ++it )
	{
		if (!Groups.contains( "#" + poldek.getInstalledValue( *it , "Group:" )))
		{
			Groups << "#"  + poldek.getInstalledValue( *it , "Group:" );
		}
	}
	Groups.sort();
	Groups << "#END";
	Installed->addChildren ( makeTree (  Groups ) ) ;
	tree-> addTopLevelItem(Installed);

	if ( !UninstallList.empty() )
	{
		if ( !InstalledKeys.contains( UninstallList.at(0) ) ){
			UninstallList.clear();
		}
	}
	if ( !installList.empty() )
	{
		if (  InstalledKeys.contains(installList[0] ) ) {
			installList.clear();
		}
	}
	setDisabled ( false );
	refreshHelpList();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::uninstallCommand() {
	if ( !UninstallList.isEmpty() )
	{
		setDisabled(true);
		poldek.runXtermCommand ( QStringList() <<  "sudo poldek -v --shcmd \"uninstall " + UninstallList.join(" ") + "\"" );
	}
	else
	{
		statusbar->showMessage( tr("Wybierz cos do deinstalowania!!") ,2000  );
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::upgradeCommand() {
	if ( !UninstallList.isEmpty() )
	{
		setDisabled(true);
		poldek.runXtermCommand ( QStringList() <<  "sudo poldek -v --shcmd \"upgrade " + UninstallList.join(" ") + "\"" );
	}
	else
	{
		statusbar->showMessage( tr("Wybierz cos do aktualizacji") ,2000  );
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::installCommand() {
	if ( !installList.isEmpty() )
	{
		setDisabled(true);
		poldek.runXtermCommand ( QStringList() <<  "sudo poldek  -v --shcmd \"install " + installList.join(" ") + "\"" );
	}
	else
	{
		statusbar->showMessage( tr("Wybierz cos do instalacji!!") , 2000);
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::upgradeAllCommand(){
	setDisabled(true);
	poldek.runXtermCommand ( QStringList() <<  "sudo poldek  -v --shcmd \"upgrade *\"" );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::pkgWyborInstall( QListWidgetItem * item )
{	
	installList << item->text();
	item->setIcon ( QIcon(":/kr_selectall.png") );
	pomocLista->addItem ( listPkg_2->takeItem( listPkg_2->row(item)) );
	pomocLista->sortItems();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::pkgWyborUninstall( QListWidgetItem * item )
{
	UninstallList << item->text();
	item->setIcon(QIcon(":/kr_unselectall.png") );
	pomocLista->addItem ( listPkg->takeItem( listPkg->row(item)) );
	pomocLista->sortItems();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::putBackItem( QListWidgetItem *item){
	item->setIcon(QIcon(":/package.png") );
	if ( UninstallList.contains(item->text()) )
	{
		listPkg->addItem ( pomocLista->takeItem( pomocLista->row(item)) );
		UninstallList.removeAll(item->text());
	}
	else
	{
		listPkg_2->addItem ( pomocLista->takeItem( pomocLista->row(item)) );
		installList.removeAll(item->text());
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 void KpoldekWindow::xtermStatus(int status ){
	poldek.InstalledList();
	refreshHelpList();
 }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


 //Funkcja ...... drzewo dla pakietw
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
QList<QTreeWidgetItem*>  KpoldekWindow::makeTree ( QStringList lista )
 {
	if ( !lista.empty() )
	{
		QString tmp = lista.at(0);
		QTreeWidgetItem *item = new QTreeWidgetItem();
		for ( QStringList::Iterator it = lista.begin() ; it  != lista.end(); it++ )
		{
			if ( !QString(*it).contains(tmp) )
			{
				QStringList help_lista;
					if ( !tmp.contains("/") )
					{
						help_lista = lista.filter( tmp ).replaceInStrings(  QString ( tmp + "/") , QString ("#") );
						help_lista << "#END";
						help_lista.removeFirst();
					}
					else
					{
						help_lista = lista.filter( tmp ).replaceInStrings(  QString ( tmp + "/") , QString ("#") );
					}
				QTreeWidgetItem *help_item = new QTreeWidgetItem();
				help_item->setIcon(  0 , QIcon (":/folder.png") );
				help_item->setText ( 0 , tmp.remove("#") );
				help_item->addChildren ( makeTree( help_lista ) );
				
				item->addChild ( help_item );
				tmp = QString ( *it );
			}
		}
		return item->takeChildren();
	}
	else
	{
		QList<QTreeWidgetItem *> puste;
		return puste;
	}
 }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 void KpoldekWindow::updateCommand(){
	setDisabled(true);
	poldek.runXtermCommand ( QStringList() <<  "sudo poldek  --up" );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::refreshAll()
{
	showAllGroups();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::reloadAll(){
	setDisabled(true);
	poldek.PkgList();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::reloadInstalled(){

}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::refreshHelpList(){
	pomocLista->clear();
	for ( QStringList::Iterator it = UninstallList.begin() ; it  != UninstallList.end(); ++it ){
		pomocLista->addItem(new QListWidgetItem ( QIcon(":/kr_unselectall.png") ,*it ));
	}
	for ( QStringList::Iterator it = installList.begin() ; it  != installList.end(); ++it ){
		pomocLista->addItem(new QListWidgetItem ( QIcon(":/kr_selectall.png") ,*it ));
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::searchPackage( QString text )
{
	QStringList InstalledKeys = poldek.getInstalledKeys();
	if ( tablica->currentIndex () == 0 )
	{
		listPkg->clear();	
		for ( QStringList::Iterator it = InstalledKeys.begin() ; it  != InstalledKeys.end(); ++it )
		{
			if (  QString(*it).left(text.count()).compare(text) == 0)
			{
				if ( !UninstallList.contains(*it) )
				{
					QListWidgetItem *item = new QListWidgetItem ( QIcon(":/package.png") ,*it );
					item->setToolTip ( poldek.getInstalledValue( *it , "Summary:" )  + "\nFile:"
									+poldek.getInstalledValue( *it , "File:" ) );
					listPkg->addItem(item);
				}
			}
		}
	}
	else
	{
		QStringList tmp = poldek.getAllKeys();
		listPkg_2->clear();	
		for ( QStringList::Iterator it = tmp.begin() ; it  != tmp.end(); ++it )
		{
			if (  QString(*it).left(text.count()).compare(text) == 0)
			{
				if ( !InstalledKeys.contains(*it) )
				{
					if ( !installList.contains(*it) )
					{
						QListWidgetItem *item = new QListWidgetItem ( QIcon(":/package.png") ,*it );
						item->setToolTip ( poldek.getAllValue( *it , "Summary:" )  + "\nFile:"
										+poldek.getAllValue( *it , "File:" ) );
						listPkg_2->addItem(item);
					}
				}
			}
		}
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::aboutAction( )
{
	about->show();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::menuSetup(){
	connect ( actionAbout , SIGNAL (triggered (  )), this , SLOT ( aboutAction ( ) ));
	connect ( actionUpdate , SIGNAL (triggered (  )), this , SLOT ( updateCommand( ) ));
	connect ( actionUpgrade , SIGNAL (triggered (  )), this , SLOT ( upgradeAllCommand() ));
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::buttonActions(){
	connect ( Uninstall_button , SIGNAL ( clicked() ) , this , SLOT ( uninstallCommand() ) );
	connect ( Install_button , SIGNAL ( clicked() ) , this , SLOT ( installCommand() ) );
	connect ( Upgrade_button , SIGNAL ( clicked() ) , this , SLOT ( upgradeCommand() ) );
	connect ( All_Upgrade , SIGNAL ( clicked() ) , this , SLOT ( upgradeAllCommand() ) );
	connect ( Update , SIGNAL ( clicked() ) , this , SLOT ( updateCommand() ) );
	connect ( Reload , SIGNAL ( clicked() ) , this , SLOT ( reloadAll() ) );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::setPoldekSignals(){
	connect ( &poldek , SIGNAL ( AllListDone() ), this , SLOT ( showAllGroups()  ) ) ;
	connect ( &poldek , SIGNAL ( InstaledListDone()), this , SLOT ( showInstalledGroups()  ) ) ;
	connect ( &poldek , SIGNAL ( xtermFinished( int )), this , SLOT ( xtermStatus(int ) ) ) ;
	connect ( &poldek  , SIGNAL ( allData ( int ) ) , progressbar , SLOT (setMaximum ( int )) );
	connect ( &poldek  , SIGNAL ( dataRead( int ) ) , progressbar , SLOT ( setValue ( int  )) );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void KpoldekWindow::setupInterface()
{

	comboBox->addItem ( tr("kde") );
	comboBox->addItem ( tr("gnome") );
	comboBox->addItem ( tr("kernel") );
	comboBox->addItem ( tr("lib") );
	//Sygnaly do tworzenia drzewa
	connect ( tree, SIGNAL (itemClicked ( QTreeWidgetItem * , int  )), this  , SLOT  ( showInstaledList(QTreeWidgetItem * , int  ) ));
	connect ( tree_2, SIGNAL (itemClicked ( QTreeWidgetItem * , int  )), this  , SLOT  ( showAllList(QTreeWidgetItem * , int  ) ));

	//Sygnaly wywolujace opis w oknie gdy zostanie kliknieta lista ale takze wybor pakietu
	connect ( listPkg_2 , SIGNAL ( itemClicked ( QListWidgetItem *  ) ) , this , SLOT (showAllDesc( QListWidgetItem *) ) );
	connect ( listPkg_2 , SIGNAL ( itemDoubleClicked ( QListWidgetItem *  ) ) , this , SLOT (pkgWyborInstall( QListWidgetItem *) ) );
	connect ( listPkg , SIGNAL (  itemClicked( QListWidgetItem *  ) ) , this , SLOT (showInstaledDesc( QListWidgetItem *) ) );
	connect ( listPkg , SIGNAL (  itemDoubleClicked( QListWidgetItem *  ) ) , this , SLOT (pkgWyborUninstall( QListWidgetItem *) ) );
	connect ( pomocLista , SIGNAL (  itemDoubleClicked( QListWidgetItem *  ) ) , this , SLOT (putBackItem( QListWidgetItem *) ) );

	//Wyszukiwanie pakitw
	connect (searchLine , SIGNAL ( textChanged ( QString  )  ) , this , SLOT (searchPackage( QString ) ) );
	connect (comboBox , SIGNAL ( activated ( QString ) ) , this , SLOT (searchPackage( QString ) ) );

	//Poczatkowe ustawienia
	tree->setHeaderLabel ( tr ("Drzewo Pakietw Zainstalowanych") );
	tree_2->setHeaderLabel ( tr ("Drzewo Pakietw Nie Zainstalowanych") );

	// Nie zmieniac tego co jest poniej to sa stale potrzebne w funkcji tworzacej drzewo....
	notInstalled->setText ( 0, "Root" );
	notInstalled->setIcon(  0 , QIcon (":/kpackage48.png") );
	Installed->setText ( 0, "Root" );
	Installed->setIcon(  0 , QIcon (":/kpackage48.png") );
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////