/***************************************************************************
 *   Copyright (C) 2007 by Bartosz Hoffmann   *
 *   monocrystal@o2.pl   *
 *                                                                         *
 ***************************************************************************/
#ifndef KPOLDEKWINDOW_H
#define KPOLDEKWINDOW_H

#include "ui_main_window.h"
#include <QApplication>
#include <QDialog>
#include <QBuffer>
#include <QThread>
#include <QProgressBar>
#include <QTreeWidgetItem>
#include <QStringListModel>
#include <QFile>
#include <QTextStream>
#include <QDir>
#include <QFSFileEngine>
#include "poldekinterface.h"
#include "aboutdialog.h"

/**
	@author Bartosz Hoffmann <monocrystal@o2.pl>
*/

	
class KpoldekWindow : public QMainWindow , private Ui::KPoldek {
	Q_OBJECT
public:
	KpoldekWindow( QWidget *parent = 0 );
private:
	void refreshAll();
	void refreshHelpList();
	void menuSetup();
	void buttonActions();
	void setupInterface();
	void setPoldekSignals();
private slots:
	void showAllDesc( QListWidgetItem *  item );
	void showInstaledDesc( QListWidgetItem *  item );
	void showInstaledList(QTreeWidgetItem * item , int column );
	void showAllList(QTreeWidgetItem * item , int column);
	void showAllGroups ();
	void showInstalledGroups ();
	void uninstallCommand();
	void installCommand();
	void upgradeCommand();
	void upgradeAllCommand();
	void pkgWyborUninstall( QListWidgetItem * item );
	void pkgWyborInstall( QListWidgetItem * item );
	void xtermStatus(int status );
	void updateCommand();
	void reloadAll();
	void reloadInstalled();
	void searchPackage( QString text );
	void putBackItem( QListWidgetItem *item);
	void aboutAction( );
private:
	PoldekInterface poldek;
	
	QStringList UninstallList;
	QStringList installList;

	AboutDialog *about;
	QTreeWidgetItem *Installed;
	QTreeWidgetItem *notInstalled;
	
	QList<QTreeWidgetItem*> makeTree (  QStringList lista );

};


#endif
