/***************************************************************************
 *   Copyright (C) 2007 by Bartosz Hoffmann   *
 *   monocrystal@o2.pl   *
 *                                                                         *
 ***************************************************************************/
#ifndef POLDEKINTERFACE_H
#define POLDEKINTERFACE_H
#include <QStringList>
#include <QProcess>
#include <QMap>
#include <QTextCodec>

/**
	@author Bartosz Hoffmann <monocrystal@o2.pl>
*/
class PoldekInterface : public QProcess {
	Q_OBJECT
public:
    		PoldekInterface( QObject *parent =0 );
void     	runPoldek ( QStringList arguments );
void 	runXtermCommand ( QStringList arguments );
void 	runRPM(  QStringList arguments);
void		InstalledList ();
void		PkgList();
void		moveToNotInstalled ( QStringList keys );

QStringList    getInstalledKeys();
QStringList    getAllKeys();
QStringList 	getAllGroups();

QString 		getInstalledValue( QString key , QString second_key );
QString 		getAllValue( QString key , QString second_key );

QStringList header;
private:
	QStringList installedPkg;
	QStringList notInstaledPkg;
	QStringList rpmHead;
	QStringList pkgGroup;
	QString	tmp_list;
 	QMap < QString , QMap<QString , QString> > instaledMap;
	QMap < QString , QMap<QString , QString > > allMap;

 	QMap < QString , QMap<QString , QString > >  parser ( QStringList lista );
private slots:
	void readStdio();
	void poldekClosed ( int exitCode, QProcess::ExitStatus exitStatus );
	void rpmClosed ( int exitCode, QProcess::ExitStatus exitStatus );
	void xtermClosed ( int exitCode, QProcess::ExitStatus exitStatus );
	void makePkgList( );
	void makeInstaledList( );
	
signals:
	void stdioReady ( QStringList stdio );
	
	void poldekFinished();
	void poldekCrash();
	
	void rpmCrash();
	void rpmFinished();
	
	void xtermFinished( int exitCode );
	void xtermCrash( int exitCode );
	
	void InstaledListDone();
	void AllListDone();
	void allData ( int size );
	void dataRead ( int data );
};

#endif
